# how to build the example (check the gcc version, if the version is inferior errors may occur)
git clone https://earth.bsc.es/gitlab/ces/eflows4hpc-wp5.git

cd /eflows4hpc-wp5/src/poc/fortran_python

# clone forpy 
git clone https://github.com/ylikx/forpy.git
# Compilation -  Python 3.7 and earlier
gfortran -o poc.a  forpy/forpy_mod.F90 hecuba_exporter.F90 main.F90 `python3-config --ldflags`
# Compilation - Python 3.8 and higher
gfortran -o poc.a  forpy/forpy_mod.F90 hecuba_exporter.F90 main.F90 `python3-config --ldflags --embed`
#to run cassandra in the container:
cassandra -R

#to check if cassandra is running:
! nodetool -h 127.0.0.1  status

! cqlsh 127.0.0.1 -e "describe keyspaces"

# set variables needed by Hecuba
export CONTACT_NAMES=127.0.0.1
export EXECUTION_NAME=docker_test

# run the example
./a.out

# check that actually it ran correctly
! cqlsh -e "select * from bsc32044.FesomOutput"

# Hecuba settings
Hecuba uses python/3.6.4_ML maybe better to use same versions for compiling
1) gcc/7.2.0 => gcc/8.1.0     
2) impi/2017.4 => impi/2018.1     
3) mkl/2017.4 => mkl/2018.1     
4) python/3.8.2 => python/3.6.4_ML
